# Unsanitized input in SQL query

## Overview

* **Rule ID**: `javascript_lang_sql_injection`
* **Applicable Languages**: Javascript
* **Weakness ID**: CWE-89

## Description

Using unsanitized data, such as user input, request data, or externally influenced data, in SQL queries exposes your application to SQL injection attacks. This vulnerability occurs when externally controlled data is directly included in SQL statements without proper sanitization, allowing attackers to manipulate queries and access or alter data.

## Remediation Guidelines

* **Avoid** using raw SQL queries that directly concatenate unsanitized input.

  ```javascript
  var sqlite = new Sequelize("sqlite::memory:");
  sqlite.query("SELECT * FROM users WHERE ID = " + req.params.userId); // unsafe

  ```
* **Validate** all query inputs to ensure they conform to expected patterns or values before using them in a query.

  ```javascript
  var rawId = req.params.userId
  if !(/[0-9]+/.test(rawId)) {
    // input is unexpected; don't make the query
  }

  ```
* **Use** prepared (or parameterized) statements for database queries to safely incorporate external input.

  ```javascript
  var sqlite = new Sequelize("sqlite::memory:");
  sqlite.query(
    "SELECT * FROM users WHERE ID = ?",
     { replacements: [req.params.userId] },
     type: sequelize.QueryTypes.SELECT
  )
  ```

## References

* [**OWASP SQL injection explained**](https://owasp.org/www-community/attacks/SQL_Injection)
* [**OWASP SQL injection prevention cheat sheet**](https://cheatsheetseries.owasp.org/cheatsheets/SQL_Injection_Prevention_Cheat_Sheet.html)
* [**CWE-89: Improper Neutralization of Special Elements used in an SQL Command ('SQL Injection')**](https://cwe.mitre.org/data/definitions/89.html)
* [**OWASP Top 10: A03:2021 - Injection**](https://owasp.org/Top10/A03_2021-Injection/)

## Configuration

To omit this rule during a scan, and to provide you with continuous 24/7 code-level scanning, you can employ our [**SAST TOOL**](https://scopy.sec1.io/login)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.sec1.io/user-docs/4-sast/3-javascript/unsanitized-user-input-in-sql-query.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
